#ifndef _TRIANGULO_H_
#define _TRIANGULO_H_

#include <iostream>
using namespace std;

struct Triangulo{
	int filas;
	int **ptr;	
};

void Inicializar(Triangulo &t); // Inicializa t a “Triángulo vacío”.

void Liberar(Triangulo &t); // Libera la memoria dinámica ocupada por el triángulo.

void NuevaFila(Triangulo &t); // Añade una nueva fila en la base del triángulo. No es necesario inicializar los elementos 
				//de la nueva fila a ningún valor concreto.
void BorraFila(Triangulo &t); // Borra la última fila del triángulo (la de la base).

void Asignar(Triangulo &t, int fil, int col, int val); // Asigna el valor val al elemento que está en la fila fil y en la columna col del triángulo.
  
int Obtener(const Triangulo &t, int fil, int col); // Devuelve el valor del elemento situado en la fila fil y la columna col.
  
int NumeroFilas(const Triangulo &t); // Devuelve el número de filas que tiene el triángulo.

void Mostrar(const Triangulo &t, int n=0); // Muestra las n primeras filas del triángulo en consola (la cúspide del triángulo). Si n
  						//vale cero (valor por defecto) mostrará el triángulo completo.


#endif
