#include "triangulo.h"
#include "pascal.h"
#include "graficos.h"
#include <iostream>

using namespace std;
using namespace graficos;

int mistrlen(char *cad){
	char *p=cad;
	int n=0;
	while(*p!='\0'){
		p++;
		n=n+1;
	}
	return n;
}

int miatoi(char *cad){
	int len=mistrlen(cad);
	int n=0;
	for(int i=0;i<len;i++){
		n=10*n+(int)(cad[i]-'0');
	}
	return n;
}


void DibujaTriangulo(Pascal p,int filas){
	int ancho=AnchoVentana();
	int alto=AltoVentana();
	int borde=(ancho*5)/100; //el borde va a ser el 5% del ancho total
	int al=(ancho-2*borde)/(2*(filas-1)); //al=incremento de l (anchura)
	int ah=(alto-2*borde)/(filas-1); //ah=incremento de h (altura)
	
	//todos los desplazamientos sobre el eje x y el eje y los he calculado a partir de la 0,0 (esquina superior izquierda)

	for(int i = 0; i<filas-1; i++){
		
		for(int j= 0; j <= i; j++){
			
			if(Obtener(p,i,j) % 2==1 && Obtener(p,i+1,j) % 2 == 1){ //une asi: /
				//x0=al*(filas-i-1)+j*2*al+borde;
				//y0=i*ah+borde;
				//x1=al*(filas-(i+1)-1)+j*2*al+borde;
				//y1=(i+1)*ah+borde;
				
				Linea(al*(filas-i-1)+j*2*al+borde, i*ah+borde, al*(filas-(i+1)-1)+j*2*al+borde, (i+1)*ah+borde,255, 0, 0,0);
			}
			if(Obtener(p,i,j) % 2==1 && Obtener(p,i+1,j+1) % 2 == 1){ //une asi: \
				//x0=al*(filas-i-1)+j*2*al+borde;
				//y0=i*ah+borde;
				//x1=al*(filas-(i+1)-1)+(j+1)*2*al+borde;
				//y1=(i+1)*ah+borde;

				Linea(al*(filas-i-1)+j*2*al+borde, i*ah+borde, al*(filas-(i+1)-1)+(j+1)*2*al+borde, (i+1)*ah+borde,255, 0, 0,0);
			}
			if(Obtener(p,i+1,j) % 2==1 && Obtener(p,i+1,j+1) % 2 == 1){ //une asi: _ 
				//x0=al*(filas-(i+1)-1)+j*2*al+borde;
				//y0=(i+1)*ah+borde;
				//x1=al*(filas-(i+1)-1)+(j+1)*2*al+borde;
				//y1=(i+1)*ah+borde;
			
				Linea(al*(filas-(i+1)-1)+j*2*al+borde, (i+1)*ah+borde, al*(filas-(i+1)-1)+(j+1)*2*al+borde, (i+1)*ah+borde,255, 0, 0,0);
			}
		}
	}
	
}

int main(int argc, char *argv[]){
	if(argc!=4){
		cout<<"Numero de parametros incorrecto:"<<endl;
		cout<<"Sintaxis= ./sierpinski <n> <filas> <columnas>"<<endl;
		exit(0);
	}
	else{
		int n=miatoi(argv[1]);
		int alto=miatoi(argv[2]);
		int ancho=miatoi(argv[3]);
		
		Pascal p;
		Inicializar(p);
		
		for (int f=2; f<=n; f++) {
  			CrearVentana(ancho,alto,"Triangulo de Sierpinski");   // Abrimos ventana
			DesactivarDibujo();
  			DibujaTriangulo(p,f);
			ActivarDibujo();
			Esperar(2000);
			
		}

  		EsperarTecla();                       // Esperamos tecla
		Liberar(p);
		
	}
}
